\section{``No Room Here for the Shirk'' (NRHS)}
\label{sec_solution}
Given the static nature of the \texttt{max}/\texttt{soft} limits, and the limited information available to the kernel it is difficult to do better.
The kernel has no information about application performance; the only metrics available to the kernel are the memory footprint, the CPU cycles used or the I/O bandwidth.
Theses are, at best, proxies for performance, and are not representative of modern applications.
Performance is best judged by the user.

Therefore, we propose to base memory reclamation on the containers' perceived performance.
We let the container itself declare that it is experiencing either ``good'' or ``bad'' performance, according to its own, application-specific metrics, compared to some performance objectives.
Based on this information, the kernel will reclaim memory from containers that have ``good'' performance.
Indeed, if a container declares ``good'' performance, this must mean that its WS fits into its current physical memory allocation.
The kernel stops reclaiming when performance becomes ``bad''.
This should tend to adapt the amount of memory to what is required for the container to perform well.
Memory reclaimed can be used by other containers to improve their own performance.

\begin{figure*} % Algorithm.
	\centering

	\begin{algorithmic}[1]
		\State $reclaimed = 0$
		\State $expected = 0$
		\ForAll{$iter \in mem\_cgroups$} \Comment {For all \texttt{cgroups} in the system.}
			\If{$iter.perf\_ok \land \neg iter.reclaimed$} \Comment{If \texttt{cgroup} has good performance and was not reclaimed in the current time slot.}
				\State $to\_take = \frac{mem\_cgroup\_usage(iter, false)}{iter.divider}$ \Comment{Take away some amount of current \texttt{cgroup} memory.}
				\State $local\_reclaimed = try\_to\_free\_mem\_cgroup\_pages(iter, to\_take)$ \Comment{Try to free this amount.}
				\State $reclaimed \mathrel{+}= local\_reclaimed$
				\State $expected \mathrel{+}= to\_take$
				\State $iter.reclaimed = true$ \Comment{Mark this \texttt{cgroup} as already reclaimed until next time slot.}
			\EndIf
		\EndFor

		\If{$expected \land reclaimed \geq expected$} \Comment{Quit if enough memory reclaimed.}

			\Return $reclaimed$
		\EndIf
		\Comment{Otherwise continue into \texttt{soft} limit mechanism.}
	\end{algorithmic}

	\caption{NRHS algorithm}
	\label{lst_oisif}
\end{figure*}

Our approach is based on two components:
\begin{enumerate}
	\item Each container has an applicative probe, which indicates to the kernel whether if it has ``good'' performance compared to some application-specific reference level.
	In our prototype, the probe consists of a \texttt{perl} script that parses the output of \texttt{sysbench} and informs Linux through \texttt{sysfs} every second.
	% Il y a un mot que je n'arrive pas à lire.
	In experiment, container A or B declares ``good'' performance if its throughput reaches 800 transactions per second when the offered workload is high, or if it handles $\approx 200$ transactions per second when it is low.
	\item We modify the Linux kernel function \texttt{mem\_cgroup\_soft\_limit\_reclaim} to reclaim some proportion of the current physical memory footprint of a container that indicates that it has ``good'' performance.
	We set this proportion to 2\% to smooth the transitions from ``good'' performance to ``bad'' ones.
	Our probe informs the kernel every second.
	Linux reclaims pages from the inactive list of the page cache.
	So, we expect that this reclaim should not hurt the performance.
	If NRHS fails to reclaim this amount of memory, the \texttt{soft} limit mechanism activates.
	Our modification is listed in Figure \ref{lst_oisif}.
	They are about $\approx 200$ lines of code.
\end{enumerate}